//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FormStatus.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmStatus *frmStatus;
//---------------------------------------------------------------------------
#include "DLLLeitura.h"
extern HINSTANCE hDLLLeitura;
//---------------------------------------------------------------------------
__fastcall TfrmStatus::TfrmStatus(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmStatus::tmrAtualizaStatusTimer(TObject *Sender)
{
 // Estrutura de dados de status a ser obtida a partir da DLL
  DLLReadStatusData StatusDLL;

  // Obtm o ponteiro para a funo de leitura das memrias
  int __cdecl (*pDLLReadStatus) (DLLReadStatusData *pStatusData);

  pDLLReadStatus = (int __cdecl (*) (DLLReadStatusData *pStatusData))
                   GetProcAddress (hDLLLeitura, "DLLReadStatus");

  // Preenche o tamanho da estrutura
  StatusDLL.nTamanhoStatus = sizeof(DLLReadStatusData);

  // Obtm o status da leitura
  (*pDLLReadStatus) (&StatusDLL);

  // Procede de acordo com a situao da DLL
  switch (StatusDLL.nSituacaoAtual)
    {
      case DLLStatErro: // Aguardando resposta  solicitao de erro.
                        // Nenhum controle precisa ser atualizado.
        break;

      case DLLStatEncerradaOK: // Leitura foi completada com sucesso
      case DLLStatEncerradaNOK:// Leitura foi completada com erro
      case DLLStatCancelada:   // Leitura binria foi cancelada

        // Fecha a tela de atualizao de status
        Close ();

        break;

      default: // Demais situaes, atualiza o status na tela.
        // Atualiza a etapa em andamento
        lblStatus->Caption = StatusDLL.szSituacaoAtual;

        // Atualiza a barra de progresso
        pbProgresso->Max = StatusDLL.lnTamanhoLeitura;
        pbProgresso->Position = StatusDLL.lnProgressoLeitura;
        break;
    }

}
//---------------------------------------------------------------------------

void __fastcall TfrmStatus::FormActivate(TObject *Sender)
{
  // Ativa a atualizao da tela de status
  tmrAtualizaStatus->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TfrmStatus::btCancelaClick(TObject *Sender)
{
  // Ponteiro para a funo de cancelamento
  void __cdecl (*pDLLReadCancelaLeitura) (void);

  pDLLReadCancelaLeitura = (void __cdecl (*) (void))
                           GetProcAddress (hDLLLeitura, "DLLReadCancelaLeitura");

  // Cancela a leitura
  (*pDLLReadCancelaLeitura) ();

  // Indica que a leitura foi cancelada
  ShowMessage ("Leitura binria cancelada pelo usurio.");
}
//---------------------------------------------------------------------------

